#include "Plateau.h"
#include "Case.h"
#include "Pion.h"
#include <stdlib.h>
#include <iostream>

Plateau::Plateau() {
  Case *depart = new CaseDepart();
  pionDuJoueur = new Pion();
  depart->place(pionDuJoueur);
  pionDuJoueur->place(depart);
  
  lesCases.push_back(depart);
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CasePiege());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CaseNormale());
  lesCases.push_back(new CasePiege());
}

void Plateau::affiche() {
  for (int i=0; i<lesCases.size(); i++) {
    lesCases[i]->affiche();
  }
  std::cout << std::endl;
}

int Plateau::getNumero(Case *c) { // recherche l'indice d'une case donnée...
  for (int i=0; i<lesCases.size(); i++) {
    if (lesCases[i]==c) return i;
  }
  return -1;
}

void Plateau::deplace(int n,int m) {
  lesCases[n]->place(0); // le pion n'est plu associé a à la case n
  pionDuJoueur->place(0);
  
  lesCases[m]->place(pionDuJoueur); // le pion est associé à la case m
  pionDuJoueur->place(lesCases[m]);
  
  lesCases[m]->effet(); // calcul de l'effet de la case
  affiche();
}

void Plateau::jeu() {
  srandom(time(NULL));
  affiche();
  do {
    int jet = random()%6+1;
    std::cout << "Dé : " << jet << std::endl;
    Case *caseCourante = pionDuJoueur->getCase();
    int numero = getNumero(caseCourante);
    int numeroSuivant = numero+jet;
    if (numeroSuivant>=lesCases.size()) break; // terminé en sortie de dernière case
    deplace(numero,numeroSuivant);
  } while (!pionDuJoueur->fin());
  std::cout << "Gagné/Perdu: " << !pionDuJoueur->fin() << std::endl;
}
                   
